﻿using AndDietCokeContract.Extensions;
using AndDietCokeContract.Infrastructure;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Numerics;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using static System.Runtime.InteropServices.JavaScript.JSType;
using System.Xml;
using AndDietCokeContract.Exceptions;

namespace AndDietCokeContract.DataModels;

public class BuyerDataModel(string id, string name, string phoneNumber, double
bonuses) : IValidation
{
    public string Id { get; private set; } = id;
    public string Name { get; private set; } = name;
    public string PhoneNumber { get; private set; } = phoneNumber;
    public double Bonuses { get; private set; } = bonuses;
    public void Validate()
    {
        if (Id.IsEmpty())
            throw new ValidationException("Field Id is empty");
        if (!Id.IsGuid())
            throw new ValidationException("The value in the field Id is not a unique identifier");
        if (Name.IsEmpty())
            throw new ValidationException("Field Name is empty");
        if (PhoneNumber.IsEmpty())
            throw new ValidationException("Field PhoneNumber is empty");
        if (!Regex.IsMatch(PhoneNumber, @"^((8|\+7)[\- ]?)?(\(?\d{3}\)?[\- ]?)?[\d\- ]{7,10}$"))
            throw new ValidationException("Field PhoneNumber is not a phone number");
    }
}
