﻿using AndDietCokeContract.Exceptions;
using AndDietCokeContract.Extensions;
using AndDietCokeContract.Infrastructure;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AndDietCokeContract.DataModels;

public class SalaryDataModel(string workerId, DateTime salaryDate, double
workerSalary) : IValidation
{
    public string WorkerId { get; private set; } = workerId;
    public DateTime SalaryDate { get; private set; } = salaryDate;
    public double Salary { get; private set; } = workerSalary;
    public void Validate()
    {
        if (WorkerId.IsEmpty())
            throw new ValidationException("Field WorkerId is empty");
        if (!WorkerId.IsGuid())
            throw new ValidationException("The value in the field WorkerId is not a unique identifier");
        if (Salary <= 0)
            throw new ValidationException("Field Salary is less than orequal to 0");
    }
}
